Index: /NEMO/trunk/src/OCE/SBC/sbcblk.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk.F90	(revision 14071)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk.F90	(revision 14072)
@@ -1182,5 +1276,12 @@
          CALL prt_ctl(tab2d_1=tprecip , clinfo1=' blk_ice: tprecip  : ', tab2d_2=sprecip , clinfo2=' sprecip  : ')
       ENDIF
-      !
+
+      !#LB:
+      ! air-ice heat flux components that are not written from ice_stp()@icestp.F90:
+      IF( iom_use('qla_ice') )  CALL iom_put( 'qla_ice', SUM( - qla_ice * a_i_b, dim=3 ) ) !#LB: sign consistent with what's done for ocean
+      IF( iom_use('qsb_ice') )  CALL iom_put( 'qsb_ice', SUM( -   z_qsb * a_i_b, dim=3 ) ) !#LB:     ==> negative => loss of heat for sea-ice
+      IF( iom_use('qlw_ice') )  CALL iom_put( 'qlw_ice', SUM(     z_qlw * a_i_b, dim=3 ) )
+      !#LB.
+
    END SUBROUTINE blk_ice_2
 
@@ -1278,170 +1379,4 @@
    END SUBROUTINE blk_ice_qcn
 
-
-   SUBROUTINE Cdn10_Lupkes2012( pcd )
-      !!----------------------------------------------------------------------
-      !!                      ***  ROUTINE  Cdn10_Lupkes2012  ***
-      !!
-      !! ** Purpose :    Recompute the neutral air-ice drag referenced at 10m
-      !!                 to make it dependent on edges at leads, melt ponds and flows.
-      !!                 After some approximations, this can be resumed to a dependency
-      !!                 on ice concentration.
-      !!
-      !! ** Method :     The parameterization is taken from Lupkes et al. (2012) eq.(50)
-      !!                 with the highest level of approximation: level4, eq.(59)
-      !!                 The generic drag over a cell partly covered by ice can be re-written as follows:
-      !!
-      !!                 Cd = Cdw * (1-A) + Cdi * A + Ce * (1-A)**(nu+1/(10*beta)) * A**mu
-      !!
-      !!                    Ce = 2.23e-3       , as suggested by Lupkes (eq. 59)
-      !!                    nu = mu = beta = 1 , as suggested by Lupkes (eq. 59)
-      !!                    A is the concentration of ice minus melt ponds (if any)
-      !!
-      !!                 This new drag has a parabolic shape (as a function of A) starting at
-      !!                 Cdw(say 1.5e-3) for A=0, reaching 1.97e-3 for A~0.5
-      !!                 and going down to Cdi(say 1.4e-3) for A=1
-      !!
-      !!                 It is theoretically applicable to all ice conditions (not only MIZ)
-      !!                 => see Lupkes et al (2013)
-      !!
-      !! ** References : Lupkes et al. JGR 2012 (theory)
-      !!                 Lupkes et al. GRL 2013 (application to GCM)
-      !!
-      !!----------------------------------------------------------------------
-      REAL(wp), DIMENSION(:,:), INTENT(inout) ::   pcd
-      REAL(wp), PARAMETER ::   zCe   = 2.23e-03_wp
-      REAL(wp), PARAMETER ::   znu   = 1._wp
-      REAL(wp), PARAMETER ::   zmu   = 1._wp
-      REAL(wp), PARAMETER ::   zbeta = 1._wp
-      REAL(wp)            ::   zcoef
-      !!----------------------------------------------------------------------
-      zcoef = znu + 1._wp / ( 10._wp * zbeta )
-
-      ! generic drag over a cell partly covered by ice
-      !!Cd(:,:) = Cd_oce(:,:) * ( 1._wp - at_i_b(:,:) ) +  &                        ! pure ocean drag
-      !!   &      Cd_ice      *           at_i_b(:,:)   +  &                        ! pure ice drag
-      !!   &      zCe         * ( 1._wp - at_i_b(:,:) )**zcoef * at_i_b(:,:)**zmu   ! change due to sea-ice morphology
-
-      ! ice-atm drag
-      pcd(:,:) = rCd_ice +  &                                                         ! pure ice drag
-         &      zCe     * ( 1._wp - at_i_b(:,:) )**zcoef * at_i_b(:,:)**(zmu-1._wp)  ! change due to sea-ice morphology
-
-   END SUBROUTINE Cdn10_Lupkes2012
-
-
-   SUBROUTINE Cdn10_Lupkes2015( ptm_su, pslp, pcd, pch )
-      !!----------------------------------------------------------------------
-      !!                      ***  ROUTINE  Cdn10_Lupkes2015  ***
-      !!
-      !! ** pUrpose :    Alternative turbulent transfert coefficients formulation
-      !!                 between sea-ice and atmosphere with distinct momentum
-      !!                 and heat coefficients depending on sea-ice concentration
-      !!                 and atmospheric stability (no meltponds effect for now).
-      !!
-      !! ** Method :     The parameterization is adapted from Lupkes et al. (2015)
-      !!                 and ECHAM6 atmospheric model. Compared to Lupkes2012 scheme,
-      !!                 it considers specific skin and form drags (Andreas et al. 2010)
-      !!                 to compute neutral transfert coefficients for both heat and
-      !!                 momemtum fluxes. Atmospheric stability effect on transfert
-      !!                 coefficient is also taken into account following Louis (1979).
-      !!
-      !! ** References : Lupkes et al. JGR 2015 (theory)
-      !!                 Lupkes et al. ECHAM6 documentation 2015 (implementation)
-      !!
-      !!----------------------------------------------------------------------
-      !
-      REAL(wp), DIMENSION(:,:), INTENT(in   ) ::   ptm_su ! sea-ice surface temperature [K]
-      REAL(wp), DIMENSION(:,:), INTENT(in   ) ::   pslp   ! sea-level pressure [Pa]
-      REAL(wp), DIMENSION(:,:), INTENT(inout) ::   pcd    ! momentum transfert coefficient
-      REAL(wp), DIMENSION(:,:), INTENT(inout) ::   pch    ! heat transfert coefficient
-      REAL(wp), DIMENSION(jpi,jpj)            ::   zst, zqo_sat, zqi_sat
-      !
-      ! ECHAM6 constants
-      REAL(wp), PARAMETER ::   z0_skin_ice  = 0.69e-3_wp  ! Eq. 43 [m]
-      REAL(wp), PARAMETER ::   z0_form_ice  = 0.57e-3_wp  ! Eq. 42 [m]
-      REAL(wp), PARAMETER ::   z0_ice       = 1.00e-3_wp  ! Eq. 15 [m]
-      REAL(wp), PARAMETER ::   zce10        = 2.80e-3_wp  ! Eq. 41
-      REAL(wp), PARAMETER ::   zbeta        = 1.1_wp      ! Eq. 41
-      REAL(wp), PARAMETER ::   zc           = 5._wp       ! Eq. 13
-      REAL(wp), PARAMETER ::   zc2          = zc * zc
-      REAL(wp), PARAMETER ::   zam          = 2. * zc     ! Eq. 14
-      REAL(wp), PARAMETER ::   zah          = 3. * zc     ! Eq. 30
-      REAL(wp), PARAMETER ::   z1_alpha     = 1._wp / 0.2_wp  ! Eq. 51
-      REAL(wp), PARAMETER ::   z1_alphaf    = z1_alpha    ! Eq. 56
-      REAL(wp), PARAMETER ::   zbetah       = 1.e-3_wp    ! Eq. 26
-      REAL(wp), PARAMETER ::   zgamma       = 1.25_wp     ! Eq. 26
-      REAL(wp), PARAMETER ::   z1_gamma     = 1._wp / zgamma
-      REAL(wp), PARAMETER ::   r1_3         = 1._wp / 3._wp
-      !
-      INTEGER  ::   ji, jj         ! dummy loop indices
-      REAL(wp) ::   zthetav_os, zthetav_is, zthetav_zu
-      REAL(wp) ::   zrib_o, zrib_i
-      REAL(wp) ::   zCdn_skin_ice, zCdn_form_ice, zCdn_ice
-      REAL(wp) ::   zChn_skin_ice, zChn_form_ice
-      REAL(wp) ::   z0w, z0i, zfmi, zfmw, zfhi, zfhw
-      REAL(wp) ::   zCdn_form_tmp
-      !!----------------------------------------------------------------------
-
-      ! Momentum Neutral Transfert Coefficients (should be a constant)
-      zCdn_form_tmp = zce10 * ( LOG( 10._wp / z0_form_ice + 1._wp ) / LOG( rn_zu / z0_form_ice + 1._wp ) )**2   ! Eq. 40
-      zCdn_skin_ice = ( vkarmn                                      / LOG( rn_zu / z0_skin_ice + 1._wp ) )**2   ! Eq. 7
-      zCdn_ice      = zCdn_skin_ice   ! Eq. 7
-      !zCdn_ice     = 1.89e-3         ! old ECHAM5 value (cf Eq. 32)
-
-      ! Heat Neutral Transfert Coefficients
-      zChn_skin_ice = vkarmn**2 / ( LOG( rn_zu / z0_ice + 1._wp ) * LOG( rn_zu * z1_alpha / z0_skin_ice + 1._wp ) )   ! Eq. 50 + Eq. 52
-
-      ! Atmospheric and Surface Variables
-      zst(:,:)     = sst_m(:,:) + rt0                                        ! convert SST from Celcius to Kelvin
-      zqo_sat(:,:) = rdct_qsat_salt * q_sat( zst(:,:)   , pslp(:,:) )   ! saturation humidity over ocean [kg/kg]
-      zqi_sat(:,:) =                  q_sat( ptm_su(:,:), pslp(:,:) )   ! saturation humidity over ice   [kg/kg]
-      !
-      DO_2D( 0, 0, 0, 0 )
-         ! Virtual potential temperature [K]
-         zthetav_os = zst(ji,jj)    * ( 1._wp + rctv0 * zqo_sat(ji,jj) )   ! over ocean
-         zthetav_is = ptm_su(ji,jj) * ( 1._wp + rctv0 * zqi_sat(ji,jj) )   ! ocean ice
-         zthetav_zu = t_zu (ji,jj)  * ( 1._wp + rctv0 * q_zu(ji,jj)    )   ! at zu
-
-         ! Bulk Richardson Number (could use Ri_bulk function from aerobulk instead)
-         zrib_o = grav / zthetav_os * ( zthetav_zu - zthetav_os ) * rn_zu / MAX( 0.5, wndm(ji,jj)     )**2   ! over ocean
-         zrib_i = grav / zthetav_is * ( zthetav_zu - zthetav_is ) * rn_zu / MAX( 0.5, wndm_ice(ji,jj) )**2   ! over ice
-
-         ! Momentum and Heat Neutral Transfert Coefficients
-         zCdn_form_ice = zCdn_form_tmp * at_i_b(ji,jj) * ( 1._wp - at_i_b(ji,jj) )**zbeta  ! Eq. 40
-         zChn_form_ice = zCdn_form_ice / ( 1._wp + ( LOG( z1_alphaf ) / vkarmn ) * SQRT( zCdn_form_ice ) )               ! Eq. 53
-
-         ! Momentum and Heat Stability functions (possibility to use psi_m_ecmwf instead ?)
-         z0w = rn_zu * EXP( -1._wp * vkarmn / SQRT( Cdn_oce(ji,jj) ) ) ! over water
-         z0i = z0_skin_ice                                             ! over ice
-         IF( zrib_o <= 0._wp ) THEN
-            zfmw = 1._wp - zam * zrib_o / ( 1._wp + 3._wp * zc2 * Cdn_oce(ji,jj) * SQRT( -zrib_o * ( rn_zu / z0w + 1._wp ) ) )  ! Eq. 10
-            zfhw = ( 1._wp + ( zbetah * ( zthetav_os - zthetav_zu )**r1_3 / ( Chn_oce(ji,jj) * MAX(0.01, wndm(ji,jj)) )   &     ! Eq. 26
-               &             )**zgamma )**z1_gamma
-         ELSE
-            zfmw = 1._wp / ( 1._wp + zam * zrib_o / SQRT( 1._wp + zrib_o ) )   ! Eq. 12
-            zfhw = 1._wp / ( 1._wp + zah * zrib_o / SQRT( 1._wp + zrib_o ) )   ! Eq. 28
-         ENDIF
-
-         IF( zrib_i <= 0._wp ) THEN
-            zfmi = 1._wp - zam * zrib_i / (1._wp + 3._wp * zc2 * zCdn_ice * SQRT( -zrib_i * ( rn_zu / z0i + 1._wp)))   ! Eq.  9
-            zfhi = 1._wp - zah * zrib_i / (1._wp + 3._wp * zc2 * zCdn_ice * SQRT( -zrib_i * ( rn_zu / z0i + 1._wp)))   ! Eq. 25
-         ELSE
-            zfmi = 1._wp / ( 1._wp + zam * zrib_i / SQRT( 1._wp + zrib_i ) )   ! Eq. 11
-            zfhi = 1._wp / ( 1._wp + zah * zrib_i / SQRT( 1._wp + zrib_i ) )   ! Eq. 27
-         ENDIF
-
-         ! Momentum Transfert Coefficients (Eq. 38)
-         pcd(ji,jj) = zCdn_skin_ice *   zfmi +  &
-            &        zCdn_form_ice * ( zfmi * at_i_b(ji,jj) + zfmw * ( 1._wp - at_i_b(ji,jj) ) ) / MAX( 1.e-06, at_i_b(ji,jj) )
-
-         ! Heat Transfert Coefficients (Eq. 49)
-         pch(ji,jj) = zChn_skin_ice *   zfhi +  &
-            &        zChn_form_ice * ( zfhi * at_i_b(ji,jj) + zfhw * ( 1._wp - at_i_b(ji,jj) ) ) / MAX( 1.e-06, at_i_b(ji,jj) )
-         !
-      END_2D
-      CALL lbc_lnk_multi( 'sbcblk', pcd, 'T',  1.0_wp, pch, 'T', 1.0_wp )
-      !
-   END SUBROUTINE Cdn10_Lupkes2015
-
 #endif
 
Index: /NEMO/trunk/src/OCE/SBC/sbcblk_algo_andreas.F90
===================================================================
--- /NEMO/trunk/src/OCE/SBC/sbcblk_algo_andreas.F90	(revision 14072)
+++ /NEMO/trunk/src/OCE/SBC/sbcblk_algo_andreas.F90	(revision 14072)
@@ -0,0 +1,337 @@
+!!! TO DO: consistent psi_m and psi_h needed!!! For now is those of NCAR !!!
+!!
+MODULE sbcblk_algo_andreas
+   !!======================================================================
+   !!                   ***  MODULE  sbcblk_algo_andreas  ***
+   !! Computes:
+   !!   * bulk transfer coefficients C_D, C_E and C_H
+   !!   * air temp. and spec. hum. adjusted from zt (2m) to zu (10m) if needed
+   !!   * the effective bulk wind speed at 10m Ubzu
+   !!  according to Andreas et al. (2015)
+   !!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+   !!       Andreas, E.L., Mahrt, L. and Vickers, D. (2015),
+   !!       An improved bulk air–sea surface flux algorithm,
+   !!       including spray‐mediated transfer.
+   !!       Q.J.R. Meteorol. Soc., 141: 642-654. doi:10.1002/qj.2424
+   !!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+   !!
+   !!   * bulk transfer coefficients C_D, C_E and C_H
+   !!   * air temp. and spec. hum. adjusted from zt (2m) to zu (10m) if needed
+   !!   * the effective bulk wind speed at z=zu: Ubzu
+   !!   => all these are used in bulk formulas in sbcblk.F90
+   !!
+   !!    Using the bulk formulation/param. of Large & Yeager 2008
+   !!
+   !!       Routine turb_andreas maintained and developed in AeroBulk
+   !!                     (https://github.com/brodeau/aerobulk/)
+   !!
+   !! ** Author: L. Brodeau, August 2020 / AeroBulk (https://github.com/brodeau/aerobulk)
+   !!----------------------------------------------------------------------
+   !! History :  4.x  !  2020-08  (L.Brodeau)   Original code
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   USE dom_oce         ! ocean space and time domain
+   USE phycst          ! physical constants
+   USE sbc_phy         ! Catalog of functions for physical/meteorological parameters in the marine boundary layer
+
+   IMPLICIT NONE
+   PRIVATE
+
+   !! Important (Brodeau fix):
+   REAL(wp), PARAMETER :: rRi_max = 0.15_wp   ! Bulk Ri above which the algorithm fucks up!
+   !                                          ! (increasing (>0) Ri means that surface layer increasingly stable and/or wind increasingly weak)
+   REAL(wp), PARAMETER :: rCs_min = 0.35E-3_wp ! minimum value to tolarate for CE and CH ! Must be larger than "Cx_min" !!!
+
+   PUBLIC :: TURB_ANDREAS, psi_m_andreas, psi_h_andreas
+
+   !! * Substitutions
+#  include "do_loop_substitute.h90"
+
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE turb_andreas( zt, zu, sst, t_zt, ssq, q_zt, U_zu, &
+      &                     Cd, Ch, Ce, t_zu, q_zu, Ubzu,       &
+      &                     nb_iter, CdN, ChN, CeN               )
+      !!----------------------------------------------------------------------------------
+      !!                      ***  ROUTINE  turb_andreas  ***
+      !!
+      !! ** Purpose :   Computes turbulent transfert coefficients of surface
+      !!                fluxes according to Large & Yeager (2004) and Large & Yeager (2008)
+      !!                If relevant (zt /= zu), adjust temperature and humidity from height zt to zu
+      !!                Returns the effective bulk wind speed at zu to be used in the bulk formulas
+      !!
+      !! INPUT :
+      !! -------
+      !!    *  zt   : height for temperature and spec. hum. of air            [m]
+      !!    *  zu   : height for wind speed (usually 10m)                     [m]
+      !!    *  sst  : bulk SST                                                [K]
+      !!    *  t_zt : potential air temperature at zt                         [K]
+      !!    *  ssq  : specific humidity at saturation at SST                  [kg/kg]
+      !!    *  q_zt : specific humidity of air at zt                          [kg/kg]
+      !!    *  U_zu : scalar wind speed at zu                                 [m/s]
+      !!
+      !! OUTPUT :
+      !! --------
+      !!    *  Cd     : drag coefficient
+      !!    *  Ch     : sensible heat coefficient
+      !!    *  Ce     : evaporation coefficient
+      !!    *  t_zu   : pot. air temperature adjusted at wind height zu       [K]
+      !!    *  q_zu   : specific humidity of air        //                    [kg/kg]
+      !!    *  Ubzu   : bulk wind speed at zu                                 [m/s]
+      !!
+      !!
+      !! ** Author: L. Brodeau, June 2019 / AeroBulk (https://github.com/brodeau/aerobulk/)
+      !!----------------------------------------------------------------------------------
+      REAL(wp), INTENT(in   )                     ::   zt       ! height for t_zt and q_zt                    [m]
+      REAL(wp), INTENT(in   )                     ::   zu       ! height for U_zu                             [m]
+      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj) ::   sst      ! sea surface temperature                [Kelvin]
+      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj) ::   t_zt     ! potential air temperature              [Kelvin]
+      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj) ::   ssq      ! sea surface specific humidity           [kg/kg]
+      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj) ::   q_zt     ! specific air humidity at zt             [kg/kg]
+      REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj) ::   U_zu     ! relative wind module at zu                [m/s]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   Cd       ! transfer coefficient for momentum         (tau)
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   Ch       ! transfer coefficient for sensible heat (Q_sens)
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   Ce       ! transfert coefficient for evaporation   (Q_lat)
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   t_zu     ! pot. air temp. adjusted at zu               [K]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   q_zu     ! spec. humidity adjusted at zu           [kg/kg]
+      REAL(wp), INTENT(  out), DIMENSION(jpi,jpj) ::   Ubzu    ! bulk wind speed at zu                     [m/s]
+      !
+      INTEGER , INTENT(in   ), OPTIONAL                     :: nb_iter  ! number of iterations
+      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(jpi,jpj) ::   CdN
+      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(jpi,jpj) ::   ChN
+      REAL(wp), INTENT(  out), OPTIONAL, DIMENSION(jpi,jpj) ::   CeN
+      !
+      INTEGER :: nbit, jit                    ! iterations...
+      LOGICAL :: l_zt_equal_zu = .FALSE.      ! if q and t are given at same height as U
+      !!
+      REAL(wp), DIMENSION(jpi,jpj) ::   u_star, t_star, q_star
+      REAL(wp), DIMENSION(jpi,jpj) ::   z0       ! roughness length (momentum) [m]
+      REAL(wp), DIMENSION(jpi,jpj) ::   UN10     ! Neutral wind speed at zu [m/s]
+      REAL(wp), DIMENSION(jpi,jpj) ::   zeta_u   ! stability parameter at height zu
+      REAL(wp), DIMENSION(jpi,jpj) ::   ztmp0, ztmp1, ztmp2
+      REAL(wp), DIMENSION(jpi,jpj) ::   RiB       ! square root of Cd
+      !!
+      !!----------------------------------------------------------------------------------
+      nbit = nb_iter0
+      IF( PRESENT(nb_iter) ) nbit = nb_iter
+
+      l_zt_equal_zu = ( ABS(zu - zt) < 0.01_wp ) ! testing "zu == zt" is risky with double precision
+
+      Ubzu = MAX( 0.25_wp , U_zu )   !  relative wind speed at zu (normally 10m), we don't want to fall under 0.5 m/s
+
+      !! First guess:
+      UN10 = Ubzu
+      Cd   = 1.1E-3_wp
+      Ch   = 1.1E-3_wp
+      Ce   = 1.1E-3_wp
+      t_zu = t_zt
+      q_zu = q_zt
+
+      !! First guess of turbulent scales for scalars:
+      ztmp0  = SQRT(Cd)
+      t_star = Ch/ztmp0*(t_zu - sst) ! theta*
+      q_star = Ce/ztmp0*(q_zu - ssq) ! q*
+
+      ! Bulk Richardson number:
+      RiB(:,:) = Ri_bulk( zu, sst, t_zu, ssq, q_zu, Ubzu )
+
+
+      !! ITERATION BLOCK
+      DO jit = 1, nbit
+
+         WHERE ( RiB < rRi_max )
+            !! Normal condition case:
+            u_star = U_STAR_ANDREAS( UN10 )
+         ELSEWHERE
+            !! Extremely stable + weak wind !!!
+            !!  => for we force u* to be consistent with minimum value for CD:
+            !!  (otherwize algorithm becomes nonsense...)
+            u_star = SQRT(Cx_min) * Ubzu     ! Cd does not go below Cx_min !
+         ENDWHERE
+
+         !! Stability parameter :
+         zeta_u = zu*One_on_L( t_zu, q_zu, u_star, t_star, q_star )   ! zu * 1/L
+
+         !! Drag coefficient:
+         ztmp0 = u_star/Ubzu
+
+         Cd = MAX( ztmp0*ztmp0 , Cx_min )
+
+         !! Roughness length:
+         z0 = MIN( z0_from_Cd( zu, Cd,  ppsi=psi_m_andreas(zeta_u) ) , z0_sea_max )
+
+         !! z0t and z0q, based on LKB, just like into COARE 2.5:
+         ztmp0 = z0 * u_star / visc_air(t_zu) ! Re_r
+         ztmp1 = z0tq_LKB( 1, ztmp0, z0 )     ! z0t
+         ztmp2 = z0tq_LKB( 2, ztmp0, z0 )     ! z0q
+
+         !! Turbulent scales at zu :
+         ztmp0 = psi_h_andreas(zeta_u)  ! lolo: zeta_u for scalars???
+         t_star  = (t_zu - sst)*vkarmn/(LOG(zu) - LOG(ztmp1) - ztmp0)  ! theta* (ztmp1 == z0t in rhs term)
+         q_star  = (q_zu - ssq)*vkarmn/(LOG(zu) - LOG(ztmp2) - ztmp0)  !   q*   (ztmp2 == z0q in rhs term)
+
+         IF( (.NOT. l_zt_equal_zu).AND.( jit > 1 ) ) THEN
+            !! Re-updating temperature and humidity at zu if zt /= zu:
+            ztmp0 = zeta_u/zu*zt   ! zeta_t
+            ztmp0 = LOG(zt/zu) + psi_h_andreas(zeta_u) - psi_h_andreas(ztmp0)
+            t_zu = t_zt - t_star/vkarmn*ztmp0
+            q_zu = q_zt - q_star/vkarmn*ztmp0
+            RiB  = Ri_bulk( zu, sst, t_zu, ssq, q_zu, Ubzu ) !LOLO
+         ENDIF
+
+         !! Update neutral-stability wind at zu:
+         UN10 = MAX( 0.1_wp , UN10_from_ustar( zu, Ubzu, u_star, psi_m_andreas(zeta_u) ) ) ! UN10
+
+      END DO !DO jit = 1, nbit
+
+      ! Compute transfer coefficients at zu:
+      ztmp0 = u_star/Ubzu
+
+      Cd = MAX( ztmp0*ztmp0 , Cx_min )   ! the earlier use of Cx_min on u* should make use of Cx_min here unnecessary!
+
+      ztmp1 = t_zu - sst ;  ztmp1 = SIGN( MAX(ABS(ztmp1),1.E-6_wp), ztmp1 )  ! dt_zu
+      ztmp2 = q_zu - ssq ;  ztmp2 = SIGN( MAX(ABS(ztmp2),1.E-9_wp), ztmp2 )  ! dq_zu
+      Ch   = MAX( ztmp0*t_star/ztmp1 , rCs_min )
+      Ce   = MAX( ztmp0*q_star/ztmp2 , rCs_min )
+
+      !! Neutral-stability coefficients:
+      ztmp0 = 1._wp/LOG(zu/z0)
+      ztmp1 = z0 * u_star / visc_air(t_zu)  ! Re_r
+      
+      IF(PRESENT(CdN)) CdN = vkarmn2*ztmp0*ztmp0
+      IF(PRESENT(ChN)) ChN = vkarmn2*ztmp0/LOG(zu/z0tq_LKB( 1, ztmp1, z0 ))
+      IF(PRESENT(CeN)) CeN = vkarmn2*ztmp0/LOG(zu/z0tq_LKB( 2, ztmp1, z0 ))
+      
+   END SUBROUTINE turb_andreas
+
+
+   FUNCTION U_STAR_ANDREAS( pun10 )
+      !!----------------------------------------------------------------------------------
+      !! Estimate of the friction velocity as a function of the neutral-stability wind
+      !! speed at at 10m
+      !!
+      !! Origin: Eq.(2.2) of Andreas et al. (2015)
+      !!
+      !! ** Author: L. Brodeau, April 2020 / AeroBulk (https://github.com/brodeau/aerobulk/)
+      !!----------------------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in) :: pun10          !: neutral-stability scalar wind speed at 10m (m/s)
+      REAL(wp), DIMENSION(jpi,jpj)             :: u_star_andreas !: friction velocity    [m/s]
+      !
+      INTEGER  ::     ji, jj ! dummy loop indices
+      REAL(wp) :: za, zt, zw ! local scalars
+      !!----------------------------------------------------------------------------------
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
+            zw  = pun10(ji,jj)
+            za = zw - 8.271_wp
+            zt = za + SQRT( 0.12_wp*za*za + 0.181_wp )
+            u_star_andreas(ji,jj) =   0.239_wp + 0.0433_wp * zt
+      END_2D
+   END FUNCTION U_STAR_ANDREAS
+
+
+   FUNCTION psi_m_andreas( pzeta )
+      !!----------------------------------------------------------------------------------
+      !!      Universal profile stability function for momentum
+      !!  TO DO !!!!!!!!!!!!!!!!!!!!!
+      !! LOLO: paper says Paulson 1970 when unstable and Grachev et al 2007 for STABLE
+      !!
+      !! pzeta : stability paramenter, z/L where z is altitude measurement
+      !!         and L is M-O length
+      !!
+      !! ** Author: L. Brodeau, April 2020 / AeroBulk (https://github.com/brodeau/aerobulk/)
+      !!----------------------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj) :: psi_m_andreas
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in) :: pzeta
+      !
+      REAL(wp), PARAMETER :: zam  = 5._wp      ! a_m (just below Eq.(9b)
+      REAL(wp), PARAMETER :: zbm = zam/6.5_wp  ! b_m (just below Eq.(9b)
+      !
+      REAL(wp), PARAMETER :: z1o3 = 1._wp/3._wp
+      REAL(wp), PARAMETER :: zsr3 = SQRT(3._wp)
+      !
+      INTEGER  ::   ji, jj    ! dummy loop indices
+      REAL(wp) :: zta, zx2, zx, zpsi_unst, zbbm, zpsi_stab,  zstab   ! local scalars
+      !!----------------------------------------------------------------------------------
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
+            !
+            zta = MIN( pzeta(ji,jj) , 15._wp ) !! Very stable conditions (L positif and big!)
+            !
+            !! *** Unstable: Paulson (1970): #LOLO: DOUBLE CHECK IT IS PAULSON!!!!!
+            zx2 = SQRT( ABS(1._wp - 16._wp*zta) )  ! (1 - 16z)^0.5
+            zx2 = MAX( zx2 , 1._wp )
+            zx  = SQRT(zx2)                          ! (1 - 16z)^0.25
+            zpsi_unst = 2._wp*LOG(ABS( (1._wp + zx )*0.5_wp ))   &
+               &            + LOG(ABS( (1._wp + zx2)*0.5_wp ))   &
+               &          - 2._wp*ATAN(zx) + rpi*0.5_wp
+            !
+            !! *** Stable: Grachev et al 2007 (SHEBA) [Eq.(12) Grachev et al 2007]:
+            zx   = ABS(1._wp + zta)**z1o3
+            zbbm = ABS( (1._wp - zbm)/zbm )**z1o3 ! B_m
+            !
+            zpsi_stab = -3.*zam/zbm*(zx - 1._wp) + zam*zbbm/(2.*zbm) * ( &
+               &        2.*LOG(ABS( (   zx     +   zbbm         )/(1._wp        +   zbbm   ) )) &
+               &         - LOG(ABS( (zx*zx - zx*zbbm + zbbm*zbbm)/(1._wp - zbbm + zbbm*zbbm) )) &
+               & + 2.*zsr3*( ATAN( (2.*zx - zbbm)/(zsr3*zbbm) ) - ATAN( (2._wp - zbbm)/(zsr3*zbbm) ) ) )
+            !
+            !
+            zstab = 0.5_wp + SIGN(0.5_wp, zta) ! zta > 0 => zstab = 1
+            !
+            psi_m_andreas(ji,jj) =       zstab  * zpsi_stab &  ! (zta > 0) Stable
+               &              + (1._wp - zstab) * zpsi_unst    ! (zta < 0) Unstable
+            !
+      END_2D
+   END FUNCTION psi_m_andreas
+
+
+   FUNCTION psi_h_andreas( pzeta )
+      !!----------------------------------------------------------------------------------
+      !! Universal profile stability function for temperature and humidity
+      !!
+      !!    TO DO
+      !!       !! LOLO: paper says Paulson 1970 when unstable and Grachev et al 2007 for STABLE
+      !!
+      !! pzeta : stability paramenter, z/L where z is altitude measurement
+      !!         and L is M-O length
+      !!
+      !! ** Author: L. Brodeau, June 2016 / AeroBulk (https://github.com/brodeau/aerobulk/)
+      !!----------------------------------------------------------------------------------
+      REAL(wp), DIMENSION(jpi,jpj) :: psi_h_andreas
+      REAL(wp), DIMENSION(jpi,jpj), INTENT(in) :: pzeta
+      !
+      REAL(wp), PARAMETER ::  zah = 5._wp       ! a_h (just below Eq.(9b)
+      REAL(wp), PARAMETER ::  zbh = 5._wp       ! b_h (just below Eq.(9b)
+      REAL(wp), PARAMETER ::  zch = 3._wp       ! c_h (just below Eq.(9b)
+      REAL(wp), PARAMETER :: zbbh = SQRT(5._wp) ! B_h (just below Eq.(13)
+      !
+      INTEGER  ::   ji, jj     ! dummy loop indices
+      REAL(wp) :: zta, zz, zx2, zpsi_unst, zpsi_stab, zstab  ! local scalars
+      !!----------------------------------------------------------------------------------
+      DO_2D( nn_hls, nn_hls, nn_hls, nn_hls )
+            !
+            zta = MIN( pzeta(ji,jj) , 15._wp ) !! Very stable conditions (L positif and large!)
+            !
+            !! *** Unstable: Paulson (1970): #LOLO: DOUBLE CHECK IT IS PAULSON!!!!!
+            zx2 = SQRT( ABS(1._wp - 16._wp*zta) )  ! (1 -16z)^0.5
+            zx2 = MAX( zx2 , 1._wp )
+            zpsi_unst = 2._wp*LOG( 0.5_wp*(1._wp + zx2) )
+            !
+            !! *** Stable: Grachev et al 2007 (SHEBA) [Eq.(13) Grachev et al 2007]:
+            zz = 2.*zta + zch
+            zpsi_stab = - 0.5*zbh*LOG(ABS(1._wp + zch*zta + zta*zta)) &
+               &        +  (-zah/zbbh + 0.5*zbh*zch/zbbh)  &
+               &          *( LOG(ABS((zz  - zbbh)/(zz  + zbbh))) &
+               &           - LOG(ABS((zch - zbbh)/(zch + zbbh)))    )
+            !
+            zstab = 0.5_wp + SIGN(0.5_wp, zta) ! zta > 0 => zstab = 1
+            !
+            psi_h_andreas(ji,jj) =            zstab  * zpsi_stab &  ! (zta > 0) Stable
+               &                   + (1._wp - zstab) * zpsi_unst    ! (zta < 0) Unstable
+            !
+      END_2D
+   END FUNCTION psi_h_andreas
+
+   !!======================================================================
+END MODULE sbcblk_algo_andreas
